Apache log4cxx Version @version@

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
SyslogAppender Class Reference

Use SyslogAppender to send log messages to a remote syslog daemon. More...

`#include <syslogappender.h>`

Inheritance diagram for SyslogAppender:

## Public Member Functions
| SyslogAppender ()
| SyslogAppender (const LayoutPtr &layout, int syslogFacility)
| SyslogAppender (const LayoutPtr &layout, const LogString &syslogHost, int syslogFacility)
| ~SyslogAppender ()
void | close ()
| Release any resources held by this SyslogAppender. More...
void | append (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &p)
| Subclasses of `AppenderSkeleton` should implement this method to perform actual logging. More...
void | activateOptions (log4cxx::helpers::Pool &p)
| This method returns immediately as options are activated when they are set. More...
void | setOption (const LogString &option, const LogString &value)
| Set `option` to `value`. More...
virtual bool | requiresLayout () const
| The SyslogAppender requires a layout. More...
void | setSyslogHost (const LogString &syslogHost)
| The SyslogHost option is the name of the the syslog host where log output should go. More...
const LogString & | getSyslogHost () const
| Returns the value of the SyslogHost option. More...
void | setFacility (const LogString &facilityName)
| Set the syslog facility. More...
LogString | getFacility () const
| Returns the value of the Facility option. More...
void | setFacilityPrinting (bool facilityPrinting1)
| If the FacilityPrinting option is set to true, the printed message will include the facility name of the application. More...
bool | getFacilityPrinting () const
| Returns the value of the FacilityPrinting option. More...
Public Member Functions inherited from AppenderSkeleton
| AppenderSkeleton ()
| AppenderSkeleton (const LayoutPtr &layout)
void | addRef () const
void | releaseRef () const
void | finalize ()
| Finalize this appender by calling the derived class' `close` method. More...
virtual void | activateOptions (log4cxx::helpers::Pool &)
| Derived appenders should override this method if option structure requires it. More...
virtual void | setOption (const LogString &option, const LogString &value)
| Set `option` to `value`. More...
void | addFilter (const spi::FilterPtr &newFilter)
| Add a filter to end of the filter list. More...
void | clearFilters ()
| Clear the filters chain. More...
const spi::ErrorHandlerPtr & | getErrorHandler () const
| Return the currently set spi::ErrorHandler for this Appender. More...
spi::FilterPtr | getFilter () const
| Returns the head Filter. More...
const spi::FilterPtr & | getFirstFilter () const
| Return the first filter in the filter chain for this Appender. More...
LayoutPtr | getLayout () const
| Returns the layout of this appender. More...
LogString | getName () const
| Returns the name of this Appender. More...
const LevelPtr & | getThreshold () const
| Returns this appenders threshold level. More...
bool | isAsSevereAsThreshold (const LevelPtr &level) const
| Check whether the message level is below the appender's threshold. More...
virtual void | doAppend (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &pool)
| This method performs threshold checks and invokes filters before delegating actual logging to the subclasses specific AppenderSkeleton::append method. More...
void | setErrorHandler (const spi::ErrorHandlerPtr &eh)
| Set the `ErrorHandler` for this Appender. More...
void | setLayout (const LayoutPtr &layout1)
| Set the layout for this appender. More...
void | setName (const LogString &name1)
| Set the name of this Appender. More...
void | setThreshold (const LevelPtr &threshold)
| Set the threshold level. More...
Public Member Functions inherited from Appender
virtual | ~Appender ()
virtual void | addFilter (const spi::FilterPtr &newFilter)=0
| Add a filter to the end of the filter list. More...
virtual spi::FilterPtr | getFilter () const =0
| Returns the head Filter. More...
virtual void | clearFilters ()=0
| Clear the list of filters by removing all the filters in it. More...
virtual void | close ()=0
| Release any resources allocated within the appender such as file handles, network connections, etc. More...
virtual void | doAppend (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &pool)=0
| Log in `Appender` specific way. More...
virtual LogString | getName () const =0
| Get the name of this appender. More...
virtual void | setLayout (const LayoutPtr &layout)=0
| Set the Layout for this appender. More...
virtual LayoutPtr | getLayout () const =0
| Returns this appenders layout. More...
virtual void | setName (const LogString &name)=0
| Set the name of this appender. More...
virtual bool | requiresLayout () const =0
| Configurators call this method to determine if the appender requires a layout. More...
Public Member Functions inherited from OptionHandler
virtual | ~OptionHandler ()
virtual void | activateOptions (log4cxx::helpers::Pool &p)=0
| Activate the options that were previously set with calls to option setters. More...
virtual void | setOption (const LogString &option, const LogString &value)=0
| Set `option` to `value`. More...
Public Member Functions inherited from Object
virtual const helpers::Class & | getClass () const
virtual | ~Object ()
virtual void | addRef () const =0
virtual void | releaseRef () const =0
virtual bool | instanceof (const Class &clazz) const =0
virtual const void * | cast (const Class &clazz) const =0
Public Member Functions inherited from ObjectImpl
| ObjectImpl ()
virtual | ~ObjectImpl ()
void | addRef () const
void | releaseRef () const

## Static Public Member Functions
static LogString | getFacilityString (int syslogFacility)
| Returns the specified syslog facility as a lower-case String, e.g. More...
static int | getFacility (const LogString &facilityName)
| Returns the integer value corresponding to the named syslog facility, or -1 if it couldn't be recognized. More...
Static Public Member Functions inherited from Object
static const helpers::Class & | getStaticClass ()
static const log4cxx::helpers::ClassRegistration & | registerClass ()

## Protected Member Functions
void | initSyslogFacilityStr ()
Protected Member Functions inherited from AppenderSkeleton
virtual void | append (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &p)=0
| Subclasses of `AppenderSkeleton` should implement this method to perform actual logging. More...
void | doAppendImpl (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &pool)

## Protected Attributes
int | syslogFacility
LogString | facilityStr
bool | facilityPrinting
helpers::SyslogWriter * | sw
LogString | syslogHost
int | syslogHostPort
Protected Attributes inherited from AppenderSkeleton
LayoutPtr | layout
| The layout variable does not need to be set if the appender implementation has its own layout. More...
LogString | name
| Appenders are named. More...
LevelPtr | threshold
| There is no level threshold filtering by default. More...
spi::ErrorHandlerPtr | errorHandler
| It is assumed and enforced that errorHandler is never null. More...
spi::FilterPtr | headFilter
| The first filter in the filter chain. More...
spi::FilterPtr | tailFilter
| The last filter in the filter chain. More...
bool | closed
| Is this appender closed? More...
log4cxx::helpers::Pool | pool
SHARED_MUTEX | mutex
Protected Attributes inherited from ObjectImpl
unsigned int volatile | ref

## Detailed Description

Use SyslogAppender to send log messages to a remote syslog daemon.

## Constructor & Destructor Documentation

## ◆ SyslogAppender() [1/3]

SyslogAppender | ( |  | ) |

## ◆ SyslogAppender() [2/3]

SyslogAppender | ( | const LayoutPtr & | layout,
|  | int | syslogFacility
| ) |  |

## ◆ SyslogAppender() [3/3]

SyslogAppender | ( | const LayoutPtr & | layout,
|  | const LogString & | syslogHost,
|  | int | syslogFacility
| ) |  |

## ◆ ~SyslogAppender()

~SyslogAppender | ( |  | ) |

## Member Function Documentation

## ◆ activateOptions()

void activateOptions | ( | log4cxx::helpers::Pool & | p | ) |
| virtual

This method returns immediately as options are activated when they are set.

Reimplemented from AppenderSkeleton.

## ◆ append()

void append | ( | const spi::LoggingEventPtr & | event,
|  | log4cxx::helpers::Pool & | p
| ) |  |
| virtual

Subclasses of `AppenderSkeleton` should implement this method to perform actual logging.

See also AppenderSkeleton::doAppend method.

Implements AppenderSkeleton.

## ◆ close()

void close | ( |  | ) |
| virtual

Release any resources held by this SyslogAppender.

Implements Appender.

## ◆ getFacility() [1/2]

LogString getFacility | ( |  | ) | const
| inline

Returns the value of the Facility option.

## ◆ getFacility() [2/2]

static int getFacility | ( | const LogString & | facilityName | ) |
| static

Returns the integer value corresponding to the named syslog facility, or -1 if it couldn't be recognized.

Parameters

  facilityName | one of the strings KERN, USER, MAIL, DAEMON, AUTH, SYSLOG, LPR, NEWS, UUCP, CRON, AUTHPRIV, FTP, LOCAL0, LOCAL1, LOCAL2, LOCAL3, LOCAL4, LOCAL5, LOCAL6, LOCAL7. The matching is case-insensitive.

## ◆ getFacilityPrinting()

bool getFacilityPrinting | ( |  | ) | const
| inline

Returns the value of the FacilityPrinting option.

## ◆ getFacilityString()

static LogString getFacilityString | ( | int | syslogFacility | ) |
| static

Returns the specified syslog facility as a lower-case String, e.g.

"kern", "user", etc.

## ◆ getSyslogHost()

const LogString & getSyslogHost | ( |  | ) | const
| inline

Returns the value of the SyslogHost option.

## ◆ initSyslogFacilityStr()

void initSyslogFacilityStr | ( |  | ) |
| protected

## ◆ requiresLayout()

virtual bool requiresLayout | ( |  | ) | const
| inline virtual

The SyslogAppender requires a layout.

Hence, this method returns `true`.

Implements Appender.

## ◆ setFacility()

void setFacility | ( | const LogString & | facilityName | ) |

Set the syslog facility.

This is the Facility option.

The `facilityName` parameter must be one of the strings KERN, USER, MAIL, DAEMON, AUTH, SYSLOG, LPR, NEWS, UUCP, CRON, AUTHPRIV, FTP, LOCAL0, LOCAL1, LOCAL2, LOCAL3, LOCAL4, LOCAL5, LOCAL6, LOCAL7. Case is unimportant.

## ◆ setFacilityPrinting()

void setFacilityPrinting | ( | bool | facilityPrinting1 | ) |
| inline

If the FacilityPrinting option is set to true, the printed message will include the facility name of the application.

It is false by default.

## ◆ setOption()

void setOption | ( | const LogString & | option,
|  | const LogString & | value
| ) |  |
| virtual

Set `option` to `value`.

The handling of each option depends on the OptionHandler instance. Some options may become active immediately whereas other may be activated only when activateOptions is called.

Reimplemented from AppenderSkeleton.

## ◆ setSyslogHost()

void setSyslogHost | ( | const LogString & | syslogHost | ) |

The SyslogHost option is the name of the the syslog host where log output should go.

WARNING If the SyslogHost is not set, then this appender will fail.

## Member Data Documentation

## ◆ facilityPrinting

bool facilityPrinting
| protected

## ◆ facilityStr

LogString facilityStr
| protected

## ◆ sw

helpers::SyslogWriter* sw
| protected

## ◆ syslogFacility

int syslogFacility
| protected

## ◆ syslogHost

LogString syslogHost
| protected

## ◆ syslogHostPort

int syslogHostPort
| protected

The documentation for this class was generated from the following file:

- syslogappender.h